POJ 3126 Prime Path

Prime Path

Time Limit: 1000MS Memory Limit: 65536K

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above。
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

思路:

挺麻烦的一题,首先我先用筛法把素数筛出来,接着用bfs遍历一遍将每个位都修改的数字,因为要最小,所以要从个位数开始修改。

#include <iostream>
#include <string>
#include <queue>
#include <cstring>
#include <cmath>
using namespace std;
bool book[10010] = {false};
bool judge[10010] = {false};
struct NODE {
	int id;
	int step;
};
void prime() {
	for (int i = 2; i < 10010; i++) {
		if (book[i] == false) {
			for (int j = 2 * i; j < 10010; j += i) {
				book[j] = true;
			}
		}
	}
}
void bfs(int l, int r) {
	queue<NODE> q;
	NODE top = {l, 0};
	q.push(top);
	while (!q.empty()) {
		NODE now = q.front();
		q.pop();
		if (now.id == r) {
			printf("%d\n", now.step);
			return ;
		}
		if (judge[now.id] == false) {
			judge[now.id] = true;
			for (int i = 0; i < 4; i++) {
				for (int j = 0; j <= 9; j++) {
					int x = 0;
					if (i == 0 && j != 0) x = now.id / 10 * 10 + j;
					else if (i == 1) {
						x = now.id / 100 * 100 + j * 10 + now.id % 10;
					} else if (i == 2) {
						x = now.id / 1000 * 1000 + j * 100 + now.id % 100;
					}
					else if (i == 3 && j != 0) x = now.id % 1000 + j * 1000; 
					if (judge[x] == false && book[x] == false && x != 0) {
						NODE node = {x, now.step + 1};
						q.push(node);
					}
				} 
			}
		}
	}
	printf("Impossible\n"); 
}
int main() {
	prime();
	int n, l, r;
	scanf("%d", &n);
	while (n--) {
		memset(judge, false, sizeof(judge));
		scanf("%d %d", &l, &r);
		bfs(l, r);
	}
	return 0;
} 
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值